/* JavaScript Document  
/  @author Ch-Nityanand Ojha
*/

var GRADE = 1;
var font_size = [40, 35, 30];
var rubricfntSize = font_size[GRADE - 1];
var optionFntSize = rubricfntSize - 5;

var drawNextQuestionDelay = 3000;
var drawIncorrectQuestionDelay = 4000;
var makeAnimationSpaceDelay = 3500;
var playAnimationDelay = 60;
var MAX_IMAGES = optionArr.length;
var MAX_CHILDREN = 4;
var introDelay = 1000;
var VERT_MARG = 15;

var fontFace = "Rubric, sans-serif";
var fontFace1 = "Ans, sans-serif";


var colorObj = { initial: "#ffff99", select: "#99ffff", defaultText: "#000000", correctText: "#009900", wrongText: "#FF0000" };
var _main;
var _rubricTxt;
var _quesTxt;
var srialNo;
var option;
var audio;
var count = 1;
var interval;
var submitBtn;
var resetBtn;

var filledCount = 0;
var correctCount = 0;
var containerEnabled = false;
var opArr = [];
var optDiv;

var Qno = 0;
var inCorrect = 0;
var selMC;
var prevBox;
var dropEnabled = false;
var attempts = 0;
var introVid;
var Stage;
var scoreDisp;
var finalScore = 0;
var storageArr = {ques:[], score:0};
var SCO;
var isFirstAttempt = true;
let lmsData;
var doubleAttemptWrong=0;
//clicknPlace();

//// G for grammer, V for vocabulary..........

var sourceOGG = "";
var sourceMP3 = "";

//var introType = "l";
startIntro();
function startIntro() {
	_main = document.getElementById(MAINTAG);
	addingCheckSolBtns();

	introVid = createTag("video");
	titleText = createTag("div");
	document.body.appendChild(introVid);

	var sourceWebm = document.createElement("source");
	var sourceMp4 = document.createElement("source");
	introVid.appendChild(sourceWebm);
	introVid.appendChild(sourceMp4);
	introVid.style.position = "absolute";
	introVid.style.top = "0px";

	introVid.addEventListener("ended", onEnd);

	if (data.intro.length == 0)
		introVid.style.visibility = 'hidden';


	//titleText.style.width = "1280px";
	titleText.style.position = "absolute";
	titleText.style.fontFamily = "Title";
	titleText.style.opacity = 0;
	titleText.style.textAlign = "center";
	titleText.style.fontSize = "50px";
	document.body.appendChild(titleText);
	//console.log("START........");


	switch (data.intro.toLowerCase()) {
		case "g":
			titleText.innerHTML = data.title || data._title;
			titleText.style.width = "630px";
			titleText.style.top = "400px";
			titleText.style.left = "590px";
			titleText.style.color = "#000";
			sourceWebm.src = "../__intro/Title_Grammar.webm"
			sourceMp4.src = "../__intro/Title_Grammar.mp4"
			introVid.load();
			introVid.play();
			setTimeout(showTitle, 3000);
			break;
		case "v":
			titleText.innerHTML = data.title || data._title;
			titleText.style.width = "712px";
			titleText.style.top = "400px";
			titleText.style.left = "205px";
			titleText.style.color = "#000";
			sourceWebm.src = "../__intro/Title_Vocab.webm"
			sourceMp4.src = "../__intro/Title_Vocab.mp4"
			introVid.load();;
			introVid.play();
			setTimeout(showTitle, 5000);
			break;
		default:
			//feedbackVid.init();
			feedbackAnim();
			document.getElementById("main").style.backgroundImage = "url('../__images/image/" + spriteOBJ.background + "')";
			introVid.removeEventListener("ended", onEnd);
			$(titleText).animate({ opacity: 0 }, 1);
			$(introVid).animate({ opacity: 0 }, 1, createLayout);
			break;

	}

}

function showTitle() {
	$(titleText).animate({ opacity: 1 }, 1000);
}

function onEnd() {
	//feedbackVid.init();
	feedbackAnim();
	document.getElementById("main").style.backgroundImage = "url('../__images/image/" + spriteOBJ.background + "')";
	introVid.removeEventListener("ended", onEnd);
	$(titleText).animate({ opacity: 0 }, introDelay);
	$(introVid).animate({ opacity: 0 }, introDelay, createLayout);
}

function feedbackAnim() {
	_main = document.getElementById("main");

	var canvasAnim = document.createElement("canvas");
	_main.appendChild(canvasAnim);
	canvasAnim.width = spriteOBJ.feedbackAnim.frames.width;
	canvasAnim.height = spriteOBJ.feedbackAnim.frames.height;
	canvasAnim.style.position = "absolute";
	canvasAnim.style.top = spriteOBJ.animTop + "px";
	canvasAnim.style.left = spriteOBJ.animLeft + "px";
	canvasAnim.setAttribute("id", "canvasAnim");

	var stage = new spritejs.Stage("canvasAnim");

	var compSprite = new spritejs.SpriteSheet(spriteOBJ.feedbackAnim);
	compSprite.on("error", function (event) {
		console.log("Error ", event);
	});

	feedbackAnim = new spritejs.Sprite(compSprite, "ideal");
	stage.addChild(feedbackAnim);


	spritejs.Ticker.addEventListener("tick", stage);
}


function createLayout() {
	//console.log("TTT:  ",TEMP);
	document.body.removeChild(introVid);
	introVid = null;
	document.body.removeChild(titleText);
	titleText = null;
	submitBtn = document.getElementById("submitBtn");
	submitBtn.style.pointerEvents = "none";
	submitBtn.style.opacity = 0.5;
	submitBtn.style.visibility = "hidden";
	submitBtn.addEventListener("click", onSubmitClick);

	resetBtn = document.getElementById("resetBtn");
	resetBtn.style.visibility = "hidden";
	resetBtn.addEventListener("click", onReset);

	srialNo = document.createElement("div");

	_main = document.getElementById("main")
	audio = document.createElement("audio");
	_main.appendChild(audio);
	sourceMP3 = document.createElement("source");
	audio.appendChild(sourceMP3)
	sourceOGG = document.createElement("source");
	audio.appendChild(sourceOGG)

	_main = document.getElementById("main");

	_rubricTxt = document.createElement("div");
	document.body.appendChild(_rubricTxt);

	_rubricTxt.setAttribute("id", "rubricTxt")
	_rubricTxt.style.maxWidth = "calc(100% - 60px)";
	rubricAud = document.createElement("span");
	_rubricTxt.append(rubricAud)
	rubricAud.setAttribute("id", "rubricAud")
	rubricAud.classList.add("customButton")
	rubricAud.style.backgroundImage = "url('../__images/audOFF.png')";
	rubricAud.addEventListener("click", onRubricAudClicked)

	rubText = document.createElement("span")
	_rubricTxt.append(rubText)
	rubText.innerHTML = data._rubric || data.rubric;

	_rubricTxt.style.position = "absolute";
	//_rubricTxt.innerHTML = rubric;

	_rubricTxt.style.background = "#fff";
	_rubricTxt.style.padding = 10 + "px";
	_rubricTxt.style.borderTopRightRadius = 10 + "px";
	_rubricTxt.style.borderBottomRightRadius = 10 + "px";
	_rubricTxt.style.left = 0 + "px";
	_rubricTxt.style.top = 15 + "px";
	_rubricTxt.style.fontSize = rubricfntSize + "px";
	_rubricTxt.style.fontFamily = fontFace;
	_rubricTxt.style.color = "#3d8eb9";



	Stage = document.createElement("div");
	Stage.setAttribute("id", "stage");
	_main.appendChild(Stage);

	Stage.addEventListener("click", onStage);
	Stage.style.pointerEvents = "none";


	soundComplete();

	//arrangeOptions();



}



function resetObj(objc) {
	if (objc) {
		objc.style.visibility = "visible";
		setColor(objc, colorObj.initial);
		enableObj(objc)
		filledCount--;
	}
}



function onRubricAudClicked(e) {
	rubricAud.style.backgroundImage = "url('../__images/audON.png')";

	sourceOGG.src = "Assets/rubric/rubric.ogg";
	sourceMP3.src = "Assets/rubric/rubric.mp3";
	audio.load();

	audio.load();
	audio.play();
	audio.addEventListener("ended", rubComplete);
}

function rubComplete() {
	audio.removeEventListener("ended", rubComplete);
	rubricAud.style.backgroundImage = "url('../__images/audOFF.png')";
	// addQuestion(0);
}

function addScorm() {
	SCO = pipwerks.SCORM;
	SCO.connection.initialize();
	console.log("INIT:  ", SCO.connection.isActive);
	if (!SCO.connection.isActive) {
		console.log("INIT ERROR");
	}

	let status = LMSget("cmi.core.lesson_status");
	let minScore = LMSget("cmi.core.score.min");


	if (!minScore) {
		LMSset("cmi.core.score.min", 0)
		LMSset("cmi.core.score.max", optionArr.length)
	}

	if (status !== "completed") {
		finalScore = LMSget("cmi.core.score.raw");
		finalScore = (finalScore=='null' || !finalScore)?0:parseInt(finalScore);
		finalScore = parseInt(finalScore);
		scoreDisp.innerHTML = finalScore + "/" + optionArr.length;
		if (optionArr.length == finalScore) {
			LMSset("cmi.core.lesson_status", "completed");
		}
		//console.log("111111: ", finalScore);
	}
	else {
		finalScore = LMSget("cmi.core.score.raw") || 0;
		finalScore = parseInt(finalScore);
		scoreDisp.innerHTML = finalScore + "/" + optionArr.length;	
		//console.log("22222222222: ", finalScore);
	}

	//console.log("SCORE: ", finalScore);
	let susData = LMSget("cmi.suspend_data");
	console.log(susData, typeof susData);
	lmsData = (susData == 'null' || !susData) ?{"ques":[], "score":0}:JSON.parse(susData);
	storageArr = lmsData;
	console.log("LMS DATA: ", lmsData);
}
function soundComplete() {
	console.log("COMP************");
	//document.getElementById("wBox").style.visibility = "visible";
	submitBtn.style.visibility = "visible";
	resetBtn.style.visibility = "visible";
	//audio.removeEventListener("ended", soundComplete);
	var scorePanel = document.createElement("div");
	_main.appendChild(scorePanel);
	scorePanel.setAttribute("id", "scorePanel");

	var scoreMeter = document.createElement("span");
	scoreMeter.innerHTML = "Score : ";
	scorePanel.appendChild(scoreMeter);
	scoreMeter.setAttribute("id", "scoreMeter");
	scoreDisp = document.createElement("span");
	// scoreDisp.innerHTML = "0/4";
	
	scorePanel.appendChild(scoreDisp);
	scoreDisp.setAttribute("id", "scoreDisp");
	addScorm();

	scoreDisp.innerHTML = finalScore + "/" + optionArr.length;
	arrangeOptions();
	createDropBoxes();
	// handlingDoneQues();

	let doneCount =0;
	lmsData.ques.forEach(element => {
		//console.log(element);		
		let cell = document.getElementById(element.id);
		if(element.isRight){
			selMC = cell;
			cell.isDone = true;
			let cont = document.getElementById(element.container);
			//console.log("********",element.container, cont);
			setContainer(cont);
			selMC.classList.add("option-right");
			selMC.style.pointerEvents = "none";
			doneCount++;
		}else if ( element.attempt == ATTEMPTS_ALLOWED){
			//console.log("-=-=-=-=-11111111");
			selMC = cell;
			var box = getCorrectBox(cell)
			setContainer(box);
			selMC.classList.add("option-right");
			selMC.style.pointerEvents = "none";
			doneCount++;
		}else{
			cell.attempt = element.attempt;
		}
		//console.log("doneCount: ", doneCount);
		if(doneCount == MAX_IMAGES){
			//console.log("ALL DONE........");			
			disableSubmitBTN();
			resetBtn.style.display = "block";
			enableReset();
		}
	});	

}

function arrangeOptions() {
	//feedbackVid.doReset();
	feedbackAnim.gotoAndStop("ideal");
	var opt;
	var count = 0;
	var prevW = 50;
	var offset = 0;
	var ln = 0;
	var wd = 0;
	var url;
	oBoxTop = 0;

	//cleanup();
	enableReset();
	clickedArr = [];
	attempts = 0;
	//console.log("LOG:  ", quesArr[currentQ]); 
	//qText = getBroken(quesArr[currentQ]);

	optDiv = createTag("div");
	optDiv.setAttribute("id", "optDv");
	getElement("main").appendChild(optDiv);
	oBoxTop = parseInt(_rubricTxt.style.top) + _rubricTxt.offsetHeight + (VERT_MARG * GRADE)
	optDiv.style.top = 143 + "px";

	for (var i = 0; i < MAX_IMAGES; i++) {
		var bg;
		var temp;
		//sNo.innerHTML = currentQ+1;
		opt = document.createElement("div");
		opt.className = "option";
		opt.setAttribute("id", "op" + i);
		opt.clicked = false;
		opt.isDone = false;
		opt.opID = count;
		opt.attempt = 0;
		// if(data.optionTyep == "image"){
			opt.innerHTML = "<img class='oImage' src='" + data._optionArr[i] + "' />";
		// }else{
		// 	opt.innerHTML = data._optionArr[i];
		// }
		opt.style.fontSize = optionFntSize + "px";
		opt.style.fontFamily = fontFace1;
		//optDiv.appendChild(opt);
		_main.appendChild(opt);
		temp = prevW + opt.offsetWidth;
		//console.log("TEMP:  ",temp,offset);
		offset = Math.max(temp, offset);
		wd = parseInt(offset / MAX_WIDTH);
		ln = ln + Math.floor(offset / MAX_WIDTH);
		if (((count + 1) % OPT_PER_ROW) == 1 && count) {
			prevW = 50;
			offset -= (optMargin + opt.offsetWidth);
			ln++;
		}
		opt.style.top = (ln * LINE_HEIGHT) + (150) + "px";
		//console.log("PREW: ", prevW, opt.offsetWidth);
		opt.style.left = (prevW) + "px";
		prevW = parseInt(opt.style.left) + 100 + optMargin;
		count++;
		//console.log("OPT1111: ", opt, opt.style.top);
		opt.addEventListener("click", onOpt);
		optDiv.style.width = 710 + "px";
		opt.xpos = parseInt(opt.style.left);
		opt.ypos = parseInt(opt.style.top);
		//console.log(i,"OFFSET:  ", offset,  "  PrevW:  ", prevW)		
		
	}

	
	
	optDiv.style.width = 710 + "px";
	optDiv.style.height = 120 + "px";//(((ln+1)*LINE_HEIGHT))+"px";
}



function createDropBoxes() {
	var prevW = 50;

	for (var i = 0; i < ansArrays.length; i++) {
		//console.log("HERE: -------------",i);
		var dropBox = createTag("div");
		var img;
		dropBox.className = "dropBoxC";
		dropBox.setAttribute("id", "dropBox" + i);
		dropBox.attempt = 0;
		dropBox.isDone = false;
		dropBox.kids = 0;
		dropBox.style.top = 286 + "px";
		//dropBox.style.left = data._pos[i].left + "px";
		
		var boxTitle = createTag("div");
		boxTitle.className = "boxTitleC";
		boxTitle.style.pointerEvents = "none";
		boxTitle.style.width = BOX_W + "px";
		dropBox.style.left = prevW + "px";
		prevW += BOX_W + 50;

		//boxTitle.style.width = 
		boxTitle.style.height = BOX_TITLE_H + "px";
		//boxTitle.innerHTML = optionArr[i];
		boxTitle.innerHTML = data._ColumnHeads[i];
		//optDiv.appendChild(dropBox);
		_main.appendChild(dropBox);
		dropBox.appendChild(boxTitle);

		_main.appendChild(dropBox);

	}

}


function onOpt(e) {

	//console.log("== ", e.target.parentNode.clicked,"       TAR:  ", e.target, "   CT:  ", e.currentTarget);
	var sel = e.target.parentNode.clicked;
	var obj = e.target.parentNode;
	//console.log("SEL: ", sel, "   obj: ", obj);

	if (sel == undefined) {
		//console.log("UNDDDDD", sel);
		obj = e.currentTarget;
		sel = e.currentTarget.clicked;
		//console.log("UNDDDDD222222", sel);
	}


	for (var i = 0; i < MAX_IMAGES; i++) {

		getElement("op" + i).classList.remove("option-selected");
		getElement("op" + i).clicked = false;
	}


	if (sel) {
		//console.log("111");
		obj.classList.remove("option-selected");
		obj.clicked = false;
		disableCotainer();
	} else {
		//console.log("222");
		obj.classList.add("option-selected");
		obj.clicked = true;
		selMC = obj;
		!dropEnabled ? enableContainer() : console.log("");
	}

	if (e.currentTarget.parentNode.className == "dropBoxC") {
		//console.log("333");
		prevBox = e.currentTarget.parentNode;

	} else {
		//console.log("444");
		Stage.style.pointerEvents = "none";
		prevBox = null;

	}
	//console.log("CLICKED: ",selMC.clicked); 

}




function addNumbering(indx) {
	srialNo.style.position = "absolute";
	srialNo.innerHTML = (indx + 1) + ".";
	srialNo.style.width = 20 + "px";
	srialNo.style.fontSize = quesfntSize;
	srialNo.style.fontFamily = fontFace;
	_main.appendChild(srialNo);
	srialNo.style.top = _quesTxt.offsetTop + "px";
	srialNo.style.left = (_quesTxt.offsetLeft - 40) + "px";
}

function enableContainer() {
	var obj;
	cont = document.getElementsByClassName("dropBoxC");
	for (var i = 0; i < cont.length; i++) {
		obj = cont[i];
		//console.log("ENA OBJ:  ", obj);
		obj.addEventListener("click", onContainer);
		//obj.style.pointerEvents="auto";
		obj.style.cursor = "pointer";
	}
	dropEnabled = true;

}

function resetContainer() {
	console.log("{00000000000000000000000000000000000");
	var obj;
	for (var i = 0; i < columnHeads[0].length; i++) {
		obj = getElement("tar" + i);
		//console.log("TAR.........",obj.isDone,i);
		if (!obj.isDone) {
			//console.log(obj+"SSSSS Reset");
			obj = getElement("tar" + i);
			obj.style.cursor = "auto";
			obj.style.color = colorObj.defaultText;
			obj.innerHTML = "";
		}
	}
}



function disableCotainer() {
	var obj;
	cont = document.getElementsByClassName("dropBoxC");
	for (var i = 0; i < cont.length; i++) {
		obj = cont[i];
		//console.log("DIS OBJ:  ", obj);
		obj.removeEventListener("click", onContainer);
		//obj.style.pointerEvents ="none";
		obj.style.cursor = "default";
	}
	dropEnabled = false;
}

function enableOpt(obj) {
	obj.style.cursor = "pointer";
	enableObj(obj);
}

function disableOpt(obj) {
	obj.style.cursor = "default";
	disableObj(obj);

}

function onContainer(e){
	var tar = e.currentTarget;
	if (e.currentTarget.childNodes.length > MAX_CHILDREN) {
		//console.log("RRRRRRRR");
		return;
	} else if (e.currentTarget.className != "dropBoxC") {
		//console.log("HERE:  ", prevBox,e.currentTarget.className);
		Stage.style.pointerEvents = "auto";
		//console.log("MAX FILLED:  ",e.target.parentNode, e.target.childNodes.length,getElement("stage").style.cursor);
		return;
	}
	setContainer(tar)
}


function setContainer(_tar) {
	var tPos = 0;
	//console.log(e.currentTarget,"++  ",e.target, "=====", e.target.parentNode);	
	var tar = _tar;
	var idd;
	var str = "";
	var obj;
	//tar = (e.target.id)?e.target:e.target.parentNode;
	//console.log("-=-=-=-=: ", tar, selMC);
	Stage.style.pointerEvents = "none";

	if (tar == selMC.parentNode) {
		//console.log("SAME.........");
		return;
	}

	tPos = tar.children.length - 1;

	if (prevBox) {
		appendAt("main", selMC);
		//console.log("11111111111");
		//appendAtGlobal(tar,selMC);
		tar.appendChild(selMC);
		selMC.clicked = false;

		refreshBox(prevBox);
		selMC.classList.remove("option-selected");

	} else {

		//appendAtGlobal(tar,selMC);
		tar.appendChild(selMC);
		//refreshBox(tar);	
		selMC.clicked = false;
		filledCount++;
		tar.kids++;
		selMC.classList.remove("option-selected");

		//console.log("KIDS:  ",  filledCount);
	}
	selMC.style.top = data.childPos[tPos].top + "px";
	selMC.style.left = data.childPos[tPos].left + "px";

	//disableCotainer();	

	checkSubmit();
}

function onStage(e) {
	Stage.style.pointerEvents = "none";
	//console.log("TARGET: ", e.target,selMC,getElement("stage").style.pointerEvents);

	appendAt("main", selMC);
	$(selMC).animate({ left: selMC.xpos, top: selMC.ypos }, 200);

	//selMC.style.left = selMC.xpos + "px";
	//selMC.style.top = selMC.ypos + "px";
	selMC.clicked = false;
	selMC.classList.remove("option-selected");
	selMC = null;
	refreshBoxAnim(prevBox);
	filledCount--;
	disableCotainer();
	checkSubmit();

}

function refreshBox(par) {
	var lft;
	var rt;
	var obj;
	console.log("refreshBox: ", par, par.childNodes);
	for (var i = 1; i < par.childNodes.length; i++) {
		console.log("COUNT:  ", i, par.childNodes[i]);
		obj = par.childNodes[i];
		lft = 50;
		rt = data.childPos[i - 1];
		obj.style.left = data.childPos[i - 1].left + "px";
		obj.style.top = data.childPos[i - 1].top + "px";
		obj.classList.remove("option-selected");
	}
	disableCotainer();
}

function refreshBoxAnim(par) {
	var lft;
	var rt;
	var obj;
	console.log("refreshBoxAnim: ", par, par.childNodes);
	for (var i = 1; i < par.childNodes.length; i++) {
		//console.log("COUNT:  ", i, par.childNodes[i]);
		obj = par.childNodes[i];
		lft = 50;
		rt = data.childPos[i - 1];
		obj.style.left = data.childPos[i - 1].left + "px";
		obj.style.top = data.childPos[i - 1].top + "px";		
	}
}



function checkSubmit() {
	//console.log("CHECK SUB:  ", filledCount, correctCount);
	if (filledCount) {
		enableSubmitBTN();
	} else {
		disableSubmitBTN();
	}
}


function getSavedData(id){
	let data = [null];
	lmsData.ques.map((ele, ind)=> {																															
		if(ele.id == id)
		{
			data = lmsData.ques.splice(ind,1)
			return ele;
		}																														 
	});
	return data[0];
}

function onSubmitClick(e) {
	var obj;
	var opt;
	var wCount = 0;
	var tempR = 0;
	var box;
	var fImage;
	var currentAttempts = 0;
	var count = 0;
	let cellData = {};
	disableSubmitBTN();
	disableReset();
	disableCotainer();
	selMC.classList.remove("option-selected");
	//selMC.clicked = false;
	selMC = null;
	attempts = 0;
	for (var i = 0; i < ansArrays.length; i++) {
		box = getElement("dropBox" + i);
		
		if (box.isDone)
			continue;
		for (var j = 1; j < box.childNodes.length; j++) {
			//console.log(box.childNodes[j].id, "IS DONE, ", box.childNodes[j].isDone, " isright: ", box.isRight);
			if(box.childNodes[j].isDone){
				continue
			}
			fImage = createTag("img");
			count++;
			cellData = getSavedData(box.childNodes[j].id) || {}		
			//console.log("*****check: ",cellData, cellData.id, cellData.attempt, cellData.isDone);
			
			cellData.id = box.childNodes[j].id;
			
			if (ansArrays[i].indexOf(box.childNodes[j].opID) == -1) {
				box.childNodes[j].classList.add("option-wrong");
				fImage.src = "Assets/images/WrongCross.png";
				disableObj(box.childNodes[j]);
				wCount++;
				box.attempt++;
				box.childNodes[j].attempt++;
				attempts = Math.max(attempts, box.childNodes[j].attempt);
				cellData.attempt = box.childNodes[j].attempt;
				cellData.isRight = false;
				
			}else{
				box.childNodes[j].classList.add("option-right");
				fImage.src = "Assets/images/RightTick.png";
				tempR++;
				
				
				cellData.attempt = box.childNodes[j].attempt + 1;
				cellData.isRight = true;
				cellData.container = "dropBox" + i;
				box.childNodes[j].isDone = true;
				disableObj(box.childNodes[j]);
				box.attempt = ATTEMPTS_ALLOWED;
				box.childNodes[j].attempt = ATTEMPTS_ALLOWED;
			}
			fImage.style.position = "absolute";
			fImage.style.left = "0px";
			fImage.style.top = "0px";
			storageArr.score = finalScore;
			//box.childNodes[j].appendChild(fImage);
			storageArr.ques.push(cellData);
		}
	}

	
	//console.log("TEMP: ", attempts);
	correctCount += tempR;
	finalScore +=  tempR;
	scoreDisp.innerHTML = finalScore + "/" + optionArr.length;
	//setTimeout(postSubmit,3000);	
	if (wCount) {
		if (attempts < ATTEMPTS_ALLOWED && tempR) {
			if (tempR <= wCount) {
				playFeedback("wrong", postWrong);
			} else {
				playFeedback("wrong", postWrong);
			}
		} else {

			playFeedback("wrong", postWrong);
		}

		//feedbackVid.playWrongFeedback();
		feedbackAnim.gotoAndPlay("wrong");
		//setTimeout(postSubmit, drawIncorrectQuestionDelay);
		//cData.attempt = attempts;		
	} else {
		//feedbackVid.playCorrectFeedback();
		feedbackAnim.gotoAndPlay("right");
		//setTimeout(postSubmit, drawNextQuestionDelay);
		//cData.allDone = true;
		playFeedback("right", postRight);
	}
	
	LMSset("cmi.suspend_data", JSON.stringify(storageArr));
	LMSset("cmi.core.score.raw", finalScore);
}

function resetOptPosition() {
	//console.log("resetOptPosition 1111111111111111");
	var obj;
	for (var i = 0; i < MAX_IMAGES; i++) {
		obj = getElement("op" + i);
		//console.log("RESET000000: ", obj, obj.parentNode);
		if (obj.classList.contains("option-wrong")) {
			//console.log("RESET: ",obj, obj.clicked, obj.isDone);	
			//obj.removeChild(obj.lastChild);
			getElement("main").appendChild(obj);
			obj.style.top = obj.ypos + "px";
			obj.style.left = obj.xpos + "px";
			obj.clicked = false;
			enableOpt(obj);
			obj.classList.remove("option-wrong");
			//$(obj).animate({left:obj.xpos, top:obj.ypos},200);
			//obj.style.left = obj.xpos + "px";
			//obj.style.top = obj.ypos + "px";
			filledCount--;
		}
	}
	//console.log("resetOptPosition 2222222222222222222");
}


function postRight() {
	feedbackAnim.gotoAndStop("ideal");
	console.log("POST=================", finalScore,doubleAttemptWrong, MAX_IMAGES);
	checkBoxes();
	if ((finalScore+doubleAttemptWrong) >= MAX_IMAGES) {
		$("video").css({ "display": "block" });
		finishActivity();
		LMSset("cmi.core.lesson_status", "completed");
	} else {
		enableReset();
		disableReset();
	}
}

function postWrong() {
	feedbackAnim.gotoAndStop("ideal");
	console.log("================ POST WRONG========");
	//console.("case3",wCount, rCount);
	resetOptPosition();
	checkBoxes();

	if (attempts >= ATTEMPTS_ALLOWED) {
		//console.log("ATT FULL");
		showCorrectAns();
	} else {
		//console.log("0-0--0-00-0-");			
		enableReset();
		disableReset();
	}
	console.log("RESET...............");
	for (var i = 0; i < ansArrays.length; i++) {
		console.log("RESETING: ", i);
		refreshBoxAnim(getElement("dropBox" + i));
	}
}


function LMSget(key){
	let val=null;
	if(!isFirstAttempt){
		return val;
	}
	// return localStorage.getItem(key);
	 try{
		val = SCO.get(key);
	}catch(err){
		console.log("LMS GET ERROR: ", val);
	}
	return val; 
}

function LMSset(key, value){	
	if(!isFirstAttempt){
		return;
	}
	// localStorage.setItem(key, value);
	try{
		SCO.set(key, value);
		SCO.save();
	}catch(err){
		console.log("LMS SET ERROR: ", err);
	} 
}

function checkBoxes() {
	var box;
	for (var i = 0; i < data._AnsArr.length; i++) {
		box = document.getElementById("dropBox" + i);
		if (box.childNodes.length > MAX_CHILDREN) {
			box.isDone = true;
		}
	}
	console.log("checkBoxes 222222222222222222");
}


function showCorrectAns() {
	var box;
	var tPos;
	var cont;
	console.log("MAX_IMAGES: ", MAX_IMAGES);
	for (var i = 0; i < MAX_IMAGES; i++) {
		box = getElement("op" + i);
		console.log(i, "@@@@@@@: ", box);
		if(box.attempt >= ATTEMPTS_ALLOWED && !box.isDone) {
			cont = getCorrectBox(box);
			console.log("SHOW CORRECT FOR: ", "op"+i);
			doubleAttemptWrong++;
			tPos = cont.children.length - 1;
			cont.appendChild(box);
			box.isDone = true;
			disableObj(box);
			//console.log("SETTING: ", box, tPos);						
			box.style.top = data.childPos[tPos].top + "px";
			box.style.left = data.childPos[tPos].left + "px";
			let key = "dropBox" + i
			/* storageArr.push({
				[key]: null,
				attempts: 0
			}); */
			correctCount++;
			
		}
		console.log("IIIII: ", i);
	}
	console.log("SHON: ", correctCount);
	playFeedback("correct", postRight);

}

function getCorrectBox(obj) {
	var id = parseInt(obj.id.toString().replace("op", ""));
	console.log("*****", id);
	for (var i = 0; i < ansArrays.length; i++) {
		if (ansArrays[i].indexOf(id) > -1) {
			return document.getElementById("dropBox" + i);
		}
	}
}


function getAnsID(id) {
	for (var i = 0; i < ansArrays.length; i++) {
		if (ansArrays[i].indexOf(id) != -1) {
			return i;
		}

	}

}



function setOptions() {
	var obj;
	for (var i = 0; i <MAX_IMAGES; i++) {
		obj = getElement("op" + i);
		console.log(obj, MAX_IMAGES);
		if (!obj.isDone) {
			//resetObj(obj);
			enableOpt(obj);
		}
		//console.log("setting", obj);
	}

	resetContainer();

}

function onReset() {
	isFirstAttempt = false;
	var obj;
	disableReset();
	disableSubmitBTN();
	for (var i = 0; i < MAX_IMAGES; i++) {
		obj = getElement("op" + i);
		obj.attempt = 0;
		obj.isDone = false;
		getElement("main").appendChild(obj);
		obj.style.top = obj.ypos + "px";
		obj.style.left = obj.xpos + "px";
		obj.clicked = false;
		enableOpt(obj);
		obj.classList.remove("option-right");
	}
	finalScore = 0;
	scoreDisp.innerHTML = finalScore + "/" + optionArr.length;
	

	//resetContainer();
	//setOptions();
	//console.log("TRRRRRRRRRRRRRR.........");
	
}

function addingCheckSolBtns() {
	checkSolution = document.createElement("div");
	checkSolution.className = "checkSolution";
	checkSolution.setAttribute("id", "checkSolution");
	_main.appendChild(checkSolution);
	resetBtn = document.createElement("div");
	//resetBtn.className = "answer";
	resetBtn.innerHTML = "RETRY";
	resetBtn.setAttribute("id", "resetBtn");
	checkSolution.appendChild(resetBtn);

	submitBtn = document.createElement("div");
	//submitBtn.className = "submit";
	submitBtn.innerHTML = "CHECK";
	submitBtn.setAttribute("id", "submitBtn");
	checkSolution.appendChild(submitBtn);


}